function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import compareType from "./../compareType";
import setValueType from "./setValueType";

// 更新value的type和isLeaf
function updateValueType(tabs, list, _ref) {
  var type = _ref.type,
    isCountry = _ref.isCountry,
    isProvince = _ref.isProvince,
    isMunicipality = _ref.isMunicipality,
    isPrefecture = _ref.isPrefecture,
    isCity = _ref.isCity,
    isDistrict = _ref.isDistrict,
    isStreet = _ref.isStreet;
  // Array type parameter is invalid
  if (!Array.isArray(tabs) || !tabs.length) {
    return tabs;
  }

  // 没有type, 则先获取type
  setValueType(tabs, {
    list: list,
    isCountry: isCountry,
    isProvince: isProvince,
    isMunicipality: isMunicipality,
    isPrefecture: isPrefecture,
    isCity: isCity,
    isDistrict: isDistrict,
    isStreet: isStreet
  });

  // 比较类型, 若符合type要求, 则增加isLeaf
  if (type) {
    var _iterator = _createForOfIteratorHelper(tabs),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var tab = _step.value;
        var currentTypes = tab.type;
        var _iterator2 = _createForOfIteratorHelper(currentTypes),
          _step2;
        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var currentType = _step2.value;
            if (compareType(currentType, type) >= 0) {
              tab.isLeaf = true;
              break;
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }

  // 只保留一项isLeaf, 多余的部分去掉
  var isLeafIndex = tabs.findIndex(function (tab) {
    return tab.isLeaf;
  });
  if (isLeafIndex !== -1) {
    return tabs.slice(0, isLeafIndex + 1);
  }
  return tabs;
}
export default updateValueType;